searchNodes=[{"ref":"MuonTrap.html","title":"MuonTrap","type":"module","doc":"MuonTrap protects you from lost and out of control processes."},{"ref":"MuonTrap.html#cmd/3","title":"MuonTrap.cmd/3","type":"function","doc":"Executes a command like System.cmd/3 via the muontrap wrapper. # Options :cgroup_controllers - run the command under the specified cgroup controllers. Defaults to []. :cgroup_path - use the specified path for the cgroup :cgroup_sets - set a cgroup controller parameter before running the command :delay_to_sigkill - milliseconds before sending a SIGKILL to a child process if it doesn&#39;t exit with a SIGTERM :uid - run the command using the specified uid or username :gid - run the command using the specified gid or group See System.cmd/3 for additional options. # Examples Run a command: iex&gt; MuonTrap.cmd(&quot;echo&quot;, [&quot;hello&quot;]) {&quot;hello\\n&quot;, 0} The next examples only run on Linux. To try this out, create new cgroups: $ sudo cgcreate -a $(whoami) -g memory,cpu:muontrap Run a command, but limit memory so severely that it doesn&#39;t work (for demo purposes, obviously): iex-donttest&gt; MuonTrap.cmd(&quot;echo&quot;, [&quot;hello&quot;], cgroup_controllers: [&quot;memory&quot;], cgroup_path: &quot;muontrap/test&quot;, cgroup_sets: [{&quot;memory&quot;, &quot;memory.limit_in_bytes&quot;, &quot;8192&quot;}]) {&quot;&quot;, 1}"},{"ref":"MuonTrap.html#muontrap_path/0","title":"MuonTrap.muontrap_path/0","type":"function","doc":"Return the absolute path to the muontrap executable. Call this if you want to invoke the muontrap port binary manually."},{"ref":"MuonTrap.Daemon.html","title":"MuonTrap.Daemon","type":"module","doc":"Wrap an OS process in a GenServer so that it can be supervised. For example, in your children list add MuonTrap.Daemon like this: children = [ {MuonTrap.Daemon, [&quot;myserver&quot;, [&quot;--options&quot;, &quot;foo&quot;)], [cd: &quot;/somedirectory&quot;]]} ] opts = [strategy: :one_for_one, name: MyApplication.Supervisor] Supervisor.start_link(children, opts) The same options as MuonTrap.cmd/3 are available with the following additions: :log_output - When set, send output from the command to the Logger. Specify the log level (e.g., :debug) :stderr_to_stdout - When set to true, redirect stderr to stdout. Defaults to false."},{"ref":"MuonTrap.Daemon.html#cgget/3","title":"MuonTrap.Daemon.cgget/3","type":"function","doc":"Get the value of the specified cgroup variable."},{"ref":"MuonTrap.Daemon.html#cgset/4","title":"MuonTrap.Daemon.cgset/4","type":"function","doc":"Modify a cgroup variable."},{"ref":"MuonTrap.Daemon.html#child_spec/1","title":"MuonTrap.Daemon.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"MuonTrap.Daemon.html#os_pid/1","title":"MuonTrap.Daemon.os_pid/1","type":"function","doc":"Return the OS pid to the muontrap executable."},{"ref":"MuonTrap.Daemon.html#start_link/3","title":"MuonTrap.Daemon.start_link/3","type":"function","doc":"Start/link a deamon GenServer for the specified command."},{"ref":"readme.html","title":"MuonTrap","type":"extras","doc":"MuonTrap Keep programs, deamons, and applications launched from Erlang and Elixir contained and well-behaved. This lightweight library kills OS processes if the Elixir process running them crashes and if you&#39;re running on Linux, it can use cgroups to prevent many other shenanigans. Some other features: Set cgroup controls like thresholds on memory and CPU utilization Start OS processes as a different user or group Send SIGKILL to processes that aren&#39;t responsive to SIGTERM With cgroups, ensure that all children of launched processes have been killed too"},{"ref":"readme.html#the-problem","title":"MuonTrap - The problem","type":"extras","doc":"The Erlang VM&#39;s port interface lets Elixir applications run external programs. This is important since it&#39;s not practical to rewrite everything in Elixir. Plus, if the program is long running like a daemon or a server, you use Elixir to supervise it and restart it on crashes. The catch is that the Erlang VM expects port processes to be well-behaved. As you&#39;d expect, many useful programs don&#39;t quite meet the Erlang VM&#39;s expectations. For example, let&#39;s say that you want to monitor a network connection and decide that ping is the right tool. Here&#39;s how you could start ping in a process. iex&gt; pid = spawn(fn -&gt; System.cmd(&quot;ping&quot;, [&quot;-i&quot;, &quot;5&quot;, &quot;localhost&quot;], into: IO.stream(:stdio, :line)) end) #PID&lt;0.6116.0&gt; PING localhost (127.0.0.1): 56 data bytes 64 bytes from 127.0.0.1: icmp_seq=0 ttl=64 time=0.032 ms 64 bytes from 127.0.0.1: icmp_seq=1 ttl=64 time=0.077 ms To see that ping is running, call ps to look for it. You can also do this from a separate terminal window outside of IEx: iex&gt; :os.cmd(&#39;ps -ef | grep ping&#39;) |&gt; IO.puts 501 38820 38587 0 9:26PM ?? 0:00.01 /sbin/ping -i 5 localhost 501 38824 38822 0 9:27PM ?? 0:00.00 grep ping :ok Now exit the Elixir process. Imagine here that in the real program that something happened in Elixir and the process needs to exit and be restarted by a supervisor. iex&gt; Process.exit(pid, :oops) true iex&gt; :os.cmd(&#39;ps -ef | grep ping&#39;) |&gt; IO.puts 501 38820 38587 0 9:26PM ?? 0:00.02 /sbin/ping -i 5 localhost 501 38833 38831 0 9:34PM ?? 0:00.00 grep ping As you can tell, ping is still running after the exit. If you run :observer you&#39;ll see that Elixir did indeed terminate both the process and the port, but that didn&#39;t stop ping. The reason for this is that ping doesn&#39;t pay attention to stdin and doesn&#39;t notice the Erlang VM closing it to signal that it should exit. Imagine now that the process was supervised and it restarts. If this happens a regularly, you could be running dozens of ping commands. This is just one of the problems that muontrap fixes."},{"ref":"readme.html#applicability","title":"MuonTrap - Applicability","type":"extras","doc":"This is intended for long running processes. It&#39;s not great for interactive programs that communicate via the port or send signals. That feature is possible to add, but you&#39;ll probably be happier with other solutions like erlexec."},{"ref":"readme.html#installation","title":"MuonTrap - Installation","type":"extras","doc":"The package can be installed by adding muontrap to your list of dependencies in mix.exs: def deps do [ {:muontrap, &quot;~&gt; 0.4&quot;} ] end"},{"ref":"readme.html#running-commands","title":"MuonTrap - Running commands","type":"extras","doc":"The simplest way to use muontrap is as a replacement to System.cmd/3. Here&#39;s an example using ping: iex&gt; pid = spawn(fn -&gt; MuonTrap.cmd(&quot;ping&quot;, [&quot;-i&quot;, &quot;5&quot;, &quot;localhost&quot;], into: IO.stream(:stdio, :line)) end) #PID&lt;0.30860.0&gt; PING localhost (127.0.0.1): 56 data bytes 64 bytes from 127.0.0.1: icmp_seq=0 ttl=64 time=0.027 ms 64 bytes from 127.0.0.1: icmp_seq=1 ttl=64 time=0.081 ms Now if you exit that process, ping gets killed as well: iex&gt; Process.exit(pid, :oops) true iex&gt; :os.cmd(&#39;ps -ef | grep ping&#39;) |&gt; IO.puts 501 38898 38896 0 9:58PM ?? 0:00.00 grep ping :ok"},{"ref":"readme.html#containment-with-cgroups","title":"MuonTrap - Containment with cgroups","type":"extras","doc":"Even if you don&#39;t make use of any cgroup controller features, having your port process contained can be useful just to make sure that everything is cleaned up on exit including any subprocesses. To set this up, first create a cgroup with appropriate permissions. Any path will do; muontrap just needs to be able to create a subdirectory underneath it for its use. For example: sudo cgcreate -a $(whoami) -g memory,cpu:mycgroup Be sure to create the group for all of the cgroup controllers that you wish to use with muontrap. The above example creates it for the memory and cpu controllers. In Elixir, call MuonTrap.cmd/3 with the cgroup options now. In this case, we&#39;ll use the cpu controller, but this example would work fine with any of the controllers. iex&gt; MuonTrap.cmd(&quot;spawning_program&quot;, [], cgroup_controllers: [&quot;cpu&quot;], cgroup_path: &quot;mycgroup/test&quot;) {&quot;hello\\n&quot;, 0} In this example, muontrap runs spawning_program in the cpu/mycgroup/test group. The cgroup parameters may be modified outside of muontrap using cgset or my accessing the cgroup mountpoint manually. On any error or if the Erlang VM closes the port or if spawning_program exits, muontrap will kill all OS processes in mycgroup/test. No need to worry about random processes accumulating on your system. Limit the memory used by a process Linux&#39;s cgroups are very powerful and the examples here only scratch the surface. If you&#39;d like to limit an OS process and all of its child processes to a maximum amount of memory, you can do that with the memory controller: iex&gt; MuonTrap.cmd(&quot;memory_hog&quot;, [], cgroup_controllers: [&quot;memory&quot;], cgroup_path: &quot;mycgroup/test2&quot;, cgroup_sets: [{&quot;memory&quot;, &quot;memory.limit_in_bytes&quot;, &quot;268435456&quot;}]) That line restricts the total memory used by memory_hog to 256 MB. Limit CPU usage in a port Limiting the maximum CPU usage is also possible. Two parameters control that with the cpu controller: cpu.cfs_period_us specifies the number of microseconds in the scheduling period and cpu.cfs_quota_us specifies how many of those microseconds can be used. Here&#39;s an example call that prevents a program from using more than 50% of the CPU: iex&gt; MuonTrap.cmd(&quot;cpu_hog&quot;, [], cgroup_controllers: [&quot;cpu&quot;], cgroup_path: &quot;mycgroup/test3&quot;, cgroup_sets: [{&quot;cpu&quot;, &quot;cpu.cfs_period_us&quot;, &quot;100000&quot;}, {&quot;cpu&quot;, &quot;cpu.cfs_quota_us&quot;, 50000}])"},{"ref":"readme.html#supervision","title":"MuonTrap - Supervision","type":"extras","doc":"For many long running programs, you may want to restart them if they crash. Luckily Erlang already has mechanisms to do this. MuonTrap provides a GenServer called MuonTrap.Daemon that you can hook into one of your supervision trees. For example, you could specify it like this in your application&#39;s supervisor:: def start(_type, _args) do children = [ {MuonTrap.Daemon, [&quot;command&quot;, [&quot;arg1&quot;, &quot;arg2&quot;], options]} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end If part of the startup of your command involves an initialization sequence, you may want to manually call MuonTrap.Daemon.start_link/3 so that if anything happens to the command or your Elixir code that it gets restarted and reinitialized automatically."},{"ref":"readme.html#muontrap-development","title":"MuonTrap - muontrap development","type":"extras","doc":"In order to run the tests, some additional tools need to be installed. Specifically the cgcreate and cgget binaries need to be installed (and available on $PATH). Typically the package may be called cgroup-tools (on arch linux you need to install the libcgroup aur package). Then run: sudo cgcreate -a $(whoami) -g memory,cpu:muontrap_test"}]